NAME

     check - Check AmigaDOS disk structure for errors

SYNOPSIS

     check volume [show]

DESCRIPTION

     Check scans the filesystem specified by "volume" for inconsistencies.
     All errors in the file structure, including any found in the
     AmigaDos redundancy information are reported.

     No attempt is made to correct the errors.  A program like "sectorama"
     or "diskx" can be used to edit disk blocks using the information obtained
     from Check.

     If Check finds an error, it will ask for permission to continue.
     Responding with a "n" will cause the current file to be skipped.
     A "y" will cause Check to attempt to continue as if the current
     block were correct.  (In general, "n" is a better response).

     The "show" command option will cause check to attempt to analyze
     any blocks in which errors are found, in order to give an indication
     of whether or not the block is seriously damaged.

     At the end of the disk scan, Check will prompt to check the
     disk bitmap.  Usually, this is a good thing to do.  Certain
     disks however, such as "kickbench" disks, will have a lot
     of information here that isn't useful.  The result of a bitmap
     scan is a list of 1) blocks that are in the bitmap but weren't
     found (these will not cause serious problems, but may be lost
     data from a previous problem) and 2) blocks that are
     found but not in the bitmap (these WILL cause serious problems
     because these blocks can be written over freely by AmigaDOS.

     Note that if you respond "y" to the "Continue [y/n]" prompt
     at any time, you may come across more blocks of the second
     type described above.

     After the bitmap scan is complete, Check prompts for the
     block analysis phase.  During this phase, enter either a decimal
     block number, or carriage return to quit.  Check will attempt to
     classify the block into the proper block type.

     Check maintains a log file in RAM:check.log.  This log file is
     closed after the bitmap scan, so you can refer to it during the
     block analysis phase (using another AmigaDOS CLI).

FILES

     RAM:check.log	-  Log file produced by running Check

REFERENCES

     For a complete description of the AmigaDOS file system, consult the
     "AmigaDOS Technical Reference Manual".

BUGS

     None known, however, Check will not work with Fast File System disks.
     Has not been tested with partitioned disks, but has been tested
     on a 40M hard disk, vd0:, and floppies.

AUTHOR

     Check V1.0 June 10, 1988 by:

     Jon L. Sherling
     1 Thames Lane
     Mount Holly, NJ 08060

     Source is available on request.
