#include "intuition/intuition.h"

/****************************************************/
/* Most of the structures in this file were created */
/*            with PowerWindows 2.5, by:            */
/* Inovatronics, Inc.                               */
/* 11311 Stemmons Freeway                           */
/* Dallas, TX  75229                                */
/* (214) 241-9515                                   */
/****************************************************/

struct NewScreen newscreen = {
        0,0,    /* screen XY origin relative to View */
        640,200,        /* screen width and height */
        2,      /* screen depth (number of bitplanes) */
        0,1,    /* detail and block pens */
        HIRES,  /* display modes for this screen */
        CUSTOMSCREEN,   /* screen type */
        NULL,   /* pointer to default screen font */
        "ShowFont 3.2 by Arthur Johnson Jr.",   /* screen title */
        NULL,   /* first in list of custom screen gadgets */
        NULL    /* pointer to custom BitMap structure */
};

struct PropInfo W_PropSInfo = {
        AUTOKNOB+FREEVERT,      /* PropInfo flags */
        -1,-1,  /* horizontal and vertical pot values */
        -1,-1,  /* horizontal and vertical body values */
};

struct Image Image1 = {
        0,0,    /* XY origin relative to container TopLeft */
        8,167,  /* Image width and height in pixels */
        0,      /* number of bitplanes in Image */
        NULL,   /* pointer to ImageData */
        0x0000,0x0000,  /* PlanePick and PlaneOnOff */
        NULL    /* next Image structure */
};

struct Gadget W_Prop = {
        NULL,   /* next gadget */
        -18,19, /* origin XY of hit box relative to window TopLeft */
        16,-29, /* hit box width and height */
        GRELRIGHT+GRELHEIGHT+GADGHNONE,   /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        PROPGADGET,     /* gadget type flags */
        (APTR)&Image1,  /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        (APTR)&W_PropSInfo,     /* SpecialInfo structure */
        2,      /* user-definable data */
        NULL    /* pointer to user-definable data */
};

USHORT GadgetDownData[] = {
        0xFFFF,0x8001,0x8181,0x8181,0x87E1,0x83C1,0x8181,0x8001,
        0xFFFF
};

struct Image GadgetDown = {
        0,0,    /* XY origin relative to container TopLeft */
        16,9,   /* Image width and height in pixels */
        2,      /* number of bitplanes in Image */
        GadgetDownData,     /* pointer to ImageData */
        0x0001,0x0000,  /* PlanePick and PlaneOnOff */
        NULL    /* next Image structure */
};

struct Gadget W_Down = {
        &W_Prop,        /* next gadget */
        -18,-9, /* origin XY of hit box relative to window TopLeft */
        18,9,   /* hit box width and height */
        GADGIMAGE+GRELBOTTOM+GRELRIGHT+GADGHNONE, /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        BOOLGADGET,     /* gadget type flags */
        (APTR)&GadgetDown,  /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        3,      /* user-definable data */
        NULL    /* pointer to user-definable data */
};

USHORT GadgetUpData[] = {
        0xFFFF,0x8001,0x8181,0x83C1,0x87E1,0x8181,0x8181,0x8001,
        0xFFFF
};

struct Image GadgetUp = {
        0,0,    /* XY origin relative to container TopLeft */
        16,9,   /* Image width and height in pixels */
        2,      /* number of bitplanes in Image */
        GadgetUpData,     /* pointer to ImageData */
        0x0001,0x0000,  /* PlanePick and PlaneOnOff */
        NULL    /* next Image structure */
};

struct Gadget W_Up = {
        &W_Down,        /* next gadget */
        -18,10, /* origin XY of hit box relative to window TopLeft */
        18,9,   /* hit box width and height */
        GADGIMAGE+GRELRIGHT+GADGHNONE,    /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        BOOLGADGET,     /* gadget type flags */
        (APTR)&GadgetUp,  /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        1,      /* user-definable data */
        NULL    /* pointer to user-definable data */
};

#define GadgetList1 W_Up

struct IntuiText IText1 = {
        3,1,COMPLEMENT, /* front and back text pens, drawmode and fill byte */
        19,0,   /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "640 x 400",    /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct MenuItem MenuItem4 = {
        NULL,   /* next MenuItem structure */
        0,24,   /* XY of Item hitbox relative to TopLeft of parent hitbox */
        91,8,   /* hit box width and height */
        CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
        7,      /* each bit mutually-excludes a same-level Item */
        (APTR)&IText1,  /* Item render  (IntuiText or Image or NULL) */
        NULL,   /* Select render */
        NULL,   /* alternate command-key */
        NULL,   /* SubItem list */
        MENUNULL        /* filled in by Intuition for drag selections */
};

struct IntuiText IText2 = {
        3,1,COMPLEMENT, /* front and back text pens, drawmode and fill byte */
        19,0,   /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "640 x 200",    /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct MenuItem MenuItem3 = {
        &MenuItem4,     /* next MenuItem structure */
        0,16,   /* XY of Item hitbox relative to TopLeft of parent hitbox */
        91,8,   /* hit box width and height */
        CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP+CHECKED,  /* Item flags */
        11,     /* each bit mutually-excludes a same-level Item */
        (APTR)&IText2,  /* Item render  (IntuiText or Image or NULL) */
        NULL,   /* Select render */
        NULL,   /* alternate command-key */
        NULL,   /* SubItem list */
        MENUNULL        /* filled in by Intuition for drag selections */
};

struct IntuiText IText3 = {
        3,1,COMPLEMENT, /* front and back text pens, drawmode and fill byte */
        19,0,   /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "320 x 400",    /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct MenuItem MenuItem2 = {
        &MenuItem3,     /* next MenuItem structure */
        0,8,    /* XY of Item hitbox relative to TopLeft of parent hitbox */
        91,8,   /* hit box width and height */
        CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
        13,     /* each bit mutually-excludes a same-level Item */
        (APTR)&IText3,  /* Item render  (IntuiText or Image or NULL) */
        NULL,   /* Select render */
        NULL,   /* alternate command-key */
        NULL,   /* SubItem list */
        MENUNULL        /* filled in by Intuition for drag selections */
};

struct IntuiText IText4 = {
        3,1,COMPLEMENT, /* front and back text pens, drawmode and fill byte */
        19,0,   /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "320 x 200",    /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct MenuItem MenuItem1 = {
        &MenuItem2,     /* next MenuItem structure */
        0,0,    /* XY of Item hitbox relative to TopLeft of parent hitbox */
        91,8,   /* hit box width and height */
        CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
        14,     /* each bit mutually-excludes a same-level Item */
        (APTR)&IText4,  /* Item render  (IntuiText or Image or NULL) */
        NULL,   /* Select render */
        NULL,   /* alternate command-key */
        NULL,   /* SubItem list */
        MENUNULL        /* filled in by Intuition for drag selections */
};

struct Menu Menu3 = {
        NULL,   /* next Menu structure */
        124,0,  /* XY origin of Menu hit box relative to screen TopLeft */
        55,0,   /* Menu hit box width and height */
        MENUENABLED,    /* Menu flags */
        "Screen",       /* text of Menu name */
        &MenuItem1      /* MenuItem linked list pointer */
};

struct IntuiText IText5 = {
        3,1,COMPLEMENT, /* front and back text pens, drawmode and fill byte */
        0,0,    /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "Font Selection",       /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct MenuItem MenuItem5 = {
        NULL,   /* next MenuItem structure */
        0,0,    /* XY of Item hitbox relative to TopLeft of parent hitbox */
        152,8,  /* hit box width and height */
        ITEMTEXT+COMMSEQ+ITEMENABLED+HIGHCOMP,      /* Item flags */
        0,      /* each bit mutually-excludes a same-level Item */
        (APTR)&IText5,  /* Item render  (IntuiText or Image or NULL) */
        NULL,   /* Select render */
        'F',    /* alternate command-key */
        NULL,   /* SubItem list */
        MENUNULL        /* filled in by Intuition for drag selections */
};

struct Menu Menu2 = {
        &Menu3, /* next Menu structure */
        70,0,   /* XY origin of Menu hit box relative to screen TopLeft */
        47,0,   /* Menu hit box width and height */
        MENUENABLED,    /* Menu flags */
        "Fonts",        /* text of Menu name */
        &MenuItem5      /* MenuItem linked list pointer */
};

struct IntuiText IText6 = {
        3,1,COMPLEMENT, /* front and back text pens, drawmode and fill byte */
        0,0,    /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "Quit", /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct MenuItem MenuItem7 = {
        NULL,   /* next MenuItem structure */
        0,8,    /* XY of Item hitbox relative to TopLeft of parent hitbox */
        80,8,   /* hit box width and height */
        ITEMTEXT+COMMSEQ+ITEMENABLED+HIGHCOMP,  /* Item flags */
        0,      /* each bit mutually-excludes a same-level Item */
        (APTR)&IText6,  /* Item render  (IntuiText or Image or NULL) */
        NULL,   /* Select render */
        'Q',    /* alternate command-key */
        NULL,   /* SubItem list */
        MENUNULL        /* filled in by Intuition for drag selections */
};

struct IntuiText IText7 = {
        3,1,COMPLEMENT, /* front and back text pens, drawmode and fill byte */
        0,0,    /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "About",        /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct MenuItem MenuItem6 = {
        &MenuItem7,     /* next MenuItem structure */
        0,0,    /* XY of Item hitbox relative to TopLeft of parent hitbox */
        80,8,   /* hit box width and height */
        ITEMTEXT+COMMSEQ+ITEMENABLED+HIGHCOMP,  /* Item flags */
        0,      /* each bit mutually-excludes a same-level Item */
        (APTR)&IText7,  /* Item render  (IntuiText or Image or NULL) */
        NULL,   /* Select render */
        'A',    /* alternate command-key */
        NULL,   /* SubItem list */
        MENUNULL        /* filled in by Intuition for drag selections */
};

struct Menu Menu1 = {
        &Menu2, /* next Menu structure */
        0,0,    /* XY origin of Menu hit box relative to screen TopLeft */
        63,0,   /* Menu hit box width and height */
        MENUENABLED,    /* Menu flags */
        "Project",      /* text of Menu name */
        &MenuItem6      /* MenuItem linked list pointer */
};

#define MenuList1 Menu1

struct NewWindow newwindow = {
        0,0,    /* window XY origin relative to TopLeft of screen */
        640,200,        /* window width and height */
        0,1,    /* detail and block pens */
        MOUSEBUTTONS+GADGETDOWN+GADGETUP+MENUPICK+CLOSEWINDOW,  /* IDCMP flags */
        WINDOWCLOSE+ACTIVATE+SMART_REFRESH,   /* other window flags */
        &W_Up,  /* first gadget in gadget list */
        NULL,   /* custom CHECKMARK imagery */
        NULL,   /* window title */
        NULL,   /* custom screen pointer */
        NULL,   /* custom bitmap */
        -1,-1,  /* minimum width and height */
        -1,-1,  /* maximum width and height */
        CUSTOMSCREEN    /* destination screen type */
};

struct Gadget R_StyleDown = {
        NULL,   /* next gadget */
        297,55, /* origin XY of hit box relative to window TopLeft */
        18,9,   /* hit box width and height */
        GADGIMAGE+GADGHNONE,      /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        BOOLGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&GadgetDown,  /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        9,     /* user-definable data */
        NULL    /* pointer to user-definable data */
};

struct PropInfo R_StyleSInfo = {
        AUTOKNOB+FREEVERT,      /* PropInfo flags */
        -1,-1,  /* horizontal and vertical pot values */
        -1,-1,  /* horizontal and vertical body values */
};

struct Image Image5 = {
        0,0,    /* XY origin relative to container TopLeft */
        8,37,   /* Image width and height in pixels */
        0,      /* number of bitplanes in Image */
        NULL,   /* pointer to ImageData */
        0x0000,0x0000,  /* PlanePick and PlaneOnOff */
        NULL    /* next Image structure */
};

struct Gadget R_Style = {
        &R_StyleDown,   /* next gadget */
        297,14, /* origin XY of hit box relative to window TopLeft */
        16,41,  /* hit box width and height */
        GADGHNONE,   /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        PROPGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&Image5,  /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        (APTR)&R_StyleSInfo,    /* SpecialInfo structure */
        8,     /* user-definable data */
        NULL    /* pointer to user-definable data */
};

struct Gadget R_StyleUp = {
        &R_Style,       /* next gadget */
        297,5,  /* origin XY of hit box relative to window TopLeft */
        18,9,   /* hit box width and height */
        GADGIMAGE+GADGHNONE,      /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        BOOLGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&GadgetUp,  /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        7,     /* user-definable data */
        NULL    /* pointer to user-definable data */
};

SHORT BorderVectors1[] = {
        0,0,
        60,0,
        60,16,
        0,16,
        0,0
};
struct Border Border1 = {
        -1,-1,  /* XY origin relative to container TopLeft */
        1,0,JAM1,       /* front pen, back pen and drawmode */
        5,      /* number of XY vectors */
        BorderVectors1, /* pointer to XY vectors */
        NULL    /* next border in list */
};

struct IntuiText IText8 = {
        1,0,JAM2,       /* front and back text pens, drawmode and fill byte */
        6,4,    /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "Cancel",       /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct Gadget R_Cancel = {
        &R_StyleUp,     /* next gadget */
        194,74, /* origin XY of hit box relative to window TopLeft */
        59,15,  /* hit box width and height */
        GADGHCOMP,   /* gadget flags */
        RELVERIFY+ENDGADGET,    /* activation flags */
        BOOLGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&Border1, /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        &IText8,        /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        102,    /* user-definable data */
        NULL    /* pointer to user-definable data */
};

SHORT BorderVectors2[] = {
        0,0,
        60,0,
        60,16,
        0,16,
        0,0
};
struct Border Border2 = {
        -1,-1,  /* XY origin relative to container TopLeft */
        1,0,JAM1,       /* front pen, back pen and drawmode */
        5,      /* number of XY vectors */
        BorderVectors2, /* pointer to XY vectors */
        NULL    /* next border in list */
};

struct IntuiText IText9 = {
        1,0,JAM2,       /* front and back text pens, drawmode and fill byte */
        20,4,   /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "OK",   /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct Gadget R_OK = {
        &R_Cancel,      /* next gadget */
        67,74,  /* origin XY of hit box relative to window TopLeft */
        59,15,  /* hit box width and height */
        GADGHCOMP,   /* gadget flags */
        RELVERIFY+ENDGADGET,    /* activation flags */
        BOOLGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&Border2, /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        &IText9,        /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        101,    /* user-definable data */
        NULL    /* pointer to user-definable data */
};

struct Gadget R_SizeDown = {
        &R_OK,  /* next gadget */
        173,55, /* origin XY of hit box relative to window TopLeft */
        18,9,   /* hit box width and height */
        GADGIMAGE+GADGHNONE,      /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        BOOLGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&GadgetDown,  /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        6,     /* user-definable data */
        NULL    /* pointer to user-definable data */
};

struct PropInfo R_SizeSInfo = {
        AUTOKNOB+FREEVERT,      /* PropInfo flags */
        -1,-1,  /* horizontal and vertical pot values */
        -1,-1,  /* horizontal and vertical body values */
};

struct Image Image8 = {
        0,0,    /* XY origin relative to container TopLeft */
        8,37,   /* Image width and height in pixels */
        0,      /* number of bitplanes in Image */
        NULL,   /* pointer to ImageData */
        0x0000,0x0000,  /* PlanePick and PlaneOnOff */
        NULL    /* next Image structure */
};

struct Gadget R_Size = {
        &R_SizeDown,    /* next gadget */
        173,14, /* origin XY of hit box relative to window TopLeft */
        16,41,  /* hit box width and height */
        GADGHNONE,   /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        PROPGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&Image8,  /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        (APTR)&R_SizeSInfo,     /* SpecialInfo structure */
        5,     /* user-definable data */
        NULL    /* pointer to user-definable data */
};

struct Gadget R_SizeUp = {
        &R_Size,        /* next gadget */
        173,5,  /* origin XY of hit box relative to window TopLeft */
        18,9,   /* hit box width and height */
        GADGIMAGE+GADGHNONE,      /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        BOOLGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&GadgetUp,  /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        4,     /* user-definable data */
        NULL    /* pointer to user-definable data */
};

struct PropInfo R_FontSInfo = {
        AUTOKNOB+FREEVERT,      /* PropInfo flags */
        -1,-1,  /* horizontal and vertical pot values */
        -1,-1,  /* horizontal and vertical body values */
};

struct Image Image10 = {
        0,0,    /* XY origin relative to container TopLeft */
        8,37,   /* Image width and height in pixels */
        0,      /* number of bitplanes in Image */
        NULL,   /* pointer to ImageData */
        0x0000,0x0000,  /* PlanePick and PlaneOnOff */
        NULL    /* next Image structure */
};

struct Gadget R_Font = {
        &R_SizeUp,      /* next gadget */
        121,14, /* origin XY of hit box relative to window TopLeft */
        16,41,  /* hit box width and height */
        GADGHNONE,   /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        PROPGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&Image10, /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        (APTR)&R_FontSInfo,     /* SpecialInfo structure */
        2,     /* user-definable data */
        NULL    /* pointer to user-definable data */
};

struct Gadget R_FontDown = {
        &R_Font,        /* next gadget */
        121,55, /* origin XY of hit box relative to window TopLeft */
        18,9,   /* hit box width and height */
        GADGIMAGE+GADGHNONE,      /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        BOOLGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&GadgetDown, /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        3,     /* user-definable data */
        NULL    /* pointer to user-definable data */
};

struct Gadget R_FontUp = {
        &R_FontDown,    /* next gadget */
        121,5,  /* origin XY of hit box relative to window TopLeft */
        18,9,   /* hit box width and height */
        GADGIMAGE+GADGHNONE,      /* gadget flags */
        RELVERIFY+GADGIMMEDIATE,        /* activation flags */
        BOOLGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&GadgetUp, /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        NULL,   /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        1,     /* user-definable data */
        NULL    /* pointer to user-definable data */
};

#define GadgetList2 R_FontUp

SHORT req1bordervectors[] = {
        0,0,
        319,0,
        319,99,
        0,99,
        0,0
};
struct Border req1border = {
        0, 0,  /* XY origin relative to container TopLeft */
        1,0,JAM1,       /* front pen, back pen and drawmode */
        5,      /* number of XY vectors */
        req1bordervectors, /* pointer to XY vectors */
        NULL    /* next border in list */
};

struct Requester requester1 = {
        NULL,   /* previous requester (filled in by Intuition) */
        160,50, /* requester XY origin relative to TopLeft of window */
        320,100,        /* requester width and height */
        0,0,    /* relative to these mouse offsets if POINTREL is set */
        &GadgetList2,   /* gadget list */
        &req1border,   /* box's border */
        NULL,   /* requester text */
        NOISYREQ,   /* requester flags */
        0,      /* back-plane fill pen */
        NULL,   /* leave these alone */
        NULL,   /* custom bitmap if PREDRAWN is set */
        NULL    /* leave this alone */
};

SHORT BorderVectors3[] = {
        0,0,
        99,0,
        99,25,
        0,25,
        0,0
};
struct Border Border3 = {
        -1,-1,  /* XY origin relative to container TopLeft */
        1,0,JAM1,       /* front pen, back pen and drawmode */
        5,      /* number of XY vectors */
        BorderVectors3, /* pointer to XY vectors */
        NULL    /* next border in list */
};

struct IntuiText IText10 = {
        1,0,JAM2,       /* front and back text pens, drawmode and fill byte */
        36,8,   /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "DUH",  /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct Gadget Gadget5 = {
        NULL,   /* next gadget */
        55,65,  /* origin XY of hit box relative to window TopLeft */
        98,24,  /* hit box width and height */
        GADGHCOMP,   /* gadget flags */
        RELVERIFY+ENDGADGET,      /* activation flags */
        BOOLGADGET+REQGADGET,   /* gadget type flags */
        (APTR)&Border3, /* gadget border or image to be rendered */
        NULL,   /* alternate imagery for selection */
        &IText10,       /* first IntuiText structure */
        NULL,   /* gadget mutual-exclude long word */
        NULL,   /* SpecialInfo structure */
        NULL,   /* user-definable data */
        NULL    /* pointer to user-definable data */
};

#define GadgetList3 Gadget5

struct IntuiText IText15 = {
        1,0,JAM2,       /* front and back text pens, drawmode and fill byte */
        80,43,  /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "fonts.",       /* pointer to text */
        NULL    /* next IntuiText structure */
};

struct IntuiText IText14 = {
        1,0,JAM2,       /* front and back text pens, drawmode and fill byte */
        20,34,  /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "This program displays",        /* pointer to text */
        &IText15        /* next IntuiText structure */
};

struct IntuiText IText13 = {
        1,0,JAM2,       /* front and back text pens, drawmode and fill byte */
        8,19,   /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "Last revision - 12/20/88",     /* pointer to text */
        &IText14        /* next IntuiText structure */
};

struct IntuiText IText12 = {
        3,0,JAM2,       /* front and back text pens, drawmode and fill byte */
        20,10,  /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "by Arthur Johnson Jr.",        /* pointer to text */
        &IText13        /* next IntuiText structure */
};

struct IntuiText IText11 = {
        3,0,JAM2,       /* front and back text pens, drawmode and fill byte */
        56,2,   /* XY origin relative to container TopLeft */
        NULL,   /* font pointer or NULL for default */
        "ShowFont 3.2", /* pointer to text */
        &IText12        /* next IntuiText structure */
};

#define IntuiTextList3 IText11

SHORT req2bordervectors[] = {
        0,0,
        207,0,
        207,99,
        0,99,
        0,0
};
struct Border req2border = {
        0, 0,  /* XY origin relative to container TopLeft */
        1,0,JAM1,       /* front pen, back pen and drawmode */
        5,      /* number of XY vectors */
        req2bordervectors, /* pointer to XY vectors */
        NULL    /* next border in list */
};

struct Requester requester2 = {
        NULL,   /* previous requester (filled in by Intuition) */
        216,50, /* requester XY origin relative to TopLeft of window */
        208,100,        /* requester width and height */
        0,0,    /* relative to these mouse offsets if POINTREL is set */
        &GadgetList3,   /* gadget list */
        &req2border,   /* box's border */
        &IntuiTextList3,        /* requester text */
        NULL,   /* requester flags */
        0,      /* back-plane fill pen */
        NULL,   /* leave these alone */
        NULL,   /* custom bitmap if PREDRAWN is set */
        NULL    /* leave this alone */
};

SHORT OutlineVectors3[] = {
        0,0,
        100,0,
        100,58,
        0,58,
        0,0
};
struct Border Outline3 = {
        194,5,  /* XY origin relative to container TopLeft */
        1,0,JAM1,       /* front pen, back pen and drawmode */
        5,      /* number of XY vectors */
        OutlineVectors3, /* pointer to XY vectors */
        NULL    /* next border in list */
};

SHORT OutlineVectors2[] = {
        0,0,
        27,0,
        27,58,
        0,58,
        0,0
};
struct Border Outline2 = {
        143,5,  /* XY origin relative to container TopLeft */
        1,0,JAM1,       /* front pen, back pen and drawmode */
        5,      /* number of XY vectors */
        OutlineVectors2, /* pointer to XY vectors */
        &Outline3        /* next border in list */
};

SHORT OutlineVectors1[] = {
        0,0,
        108,0,
        108,58,
        0,58,
        0,0
};
struct Border Outline1 = {
        10,5,   /* XY origin relative to container TopLeft */
        1,0,JAM1,       /* front pen, back pen and drawmode */
        5,      /* number of XY vectors */
        OutlineVectors1, /* pointer to XY vectors */
        &Outline2        /* next border in list */
};
